"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mask = exports.unMask = void 0;
const vanilla_masker_1 = require("vanilla-masker");
const unMask = (value) => value.replace(/\W/g, '');
exports.unMask = unMask;
const masker = (value, pattern, options) => (0, vanilla_masker_1.toPattern)(value, Object.assign({ pattern }, options));
const multimasker = (value, patterns, options) => masker(value, patterns.reduce((memo, pattern) => (value.length <= (0, exports.unMask)(memo).length ? memo : pattern), patterns[0]), options);
const mask = (value, pattern, options) => typeof pattern === 'string'
    ? masker(value, pattern || '', options)
    : multimasker(value, pattern, options);
exports.mask = mask;
